#!/bin/bash

run=0

while /bin/true; do

	rm /mnt/data/pg.log
	pg_ctl -D /mnt/raid/pgdata-brin-13 -l /mnt/data/pg.log -w -t 3600 restart

        run=$((run+1))

	mkdir -p runs/$run

        date

        echo RUN $run

        NULL_PCT=$((RANDOM % 100))
        SUM_PCT=$((RANDOM % 100))
        ROWS=10000

	echo "-- $ROWS $NULL_PCT $SUM_PCT"
        echo "-- $ROWS $NULL_PCT $SUM_PCT" > runs/$run/init.sql

        echo 'drop table if exists t;' >> runs/$run/init.sql
        echo 'create table t (a int) with (fillfactor = 10);' >> runs/$run/init.sql
        echo 'create index t_a_idx on t using brin (a) with (pages_per_range=1);' >> runs/$run/init.sql

        echo `date` 'generate data'
        for v in `seq 1 $ROWS`; do
                echo "insert into t values (case when random() * 100 < $NULL_PCT then null else 1000 * random() end);" >> runs/$run/init.sql

                r=$((RANDOM % 100))

                if [ $r -lt $SUM_PCT ]; then
                        echo "select brin_summarize_new_values('t_a_idx');" >> runs/$run/init.sql
                fi
        done

        psql test < runs/$run/init.sql > init.log 2>&1

        for r in `seq 1 10`; do

            echo `date` "  run pgbench run $r"
            pgbench -n -c 16 -f update.sql@9 -f desummarize.sql@1 -f summarize.sql@1 -T 10 test > runs/$run/pgbench-a-$r.log 2>&1

        done

        for r in `seq 1 10`; do

            echo `date` "  run pgbench B run $r"
            pgbench -n -c 16 -f update.sql@9 -f resummarize.sql@1 -T 10 test > runs/$run/pgbench-b-$r.log 2>&1

        done

done
